function patches = Img2Patches(src_Img, patch_H, patch_W)
patch_w = (patch_W-1) / 2;
patch_h = (patch_H-1) / 2;
patch_Dim = patch_W * patch_H;
[patch_X patch_Y] = meshgrid(-patch_w:patch_w, -patch_h:patch_h);
pad_Src_Img = padarray(src_Img, [patch_w patch_h], 'both');
[pad_Img_H pad_Img_W] = size(pad_Src_Img);
[patches_x patches_y] = meshgrid(1+patch_w:pad_Img_W - patch_w, 1+patch_h:pad_Img_H - patch_h);
patch_Num = numel(patches_x);
patch_xx = repmat(patch_X(:)', [patch_Num 1]) + repmat(patches_x(:), [1 patch_Dim]);
patch_yy = repmat(patch_Y(:)', [patch_Num 1]) + repmat(patches_y(:), [1 patch_Dim]);
index = sub2ind([pad_Img_H pad_Img_W], patch_yy(:), patch_xx(:));
patches = reshape(pad_Src_Img(index), [patch_Num patch_Dim]);
patches = patches';
